# rust-contract-sdk

Documentation is automatically updated, and is found [here](https://privacyblockchain.gitlab.io/language/rust-contract-sdk).

## A note on versioning

A blockchain is a complex piece of software, employing many components with many active versions. Here is an overview of the _types of versions_ associated with the SDK:

- **SDK crate version**: Version of the crate itself. Incremented for every
  change of the crate's code.
- **Binder ABI version**: Tracks which ABI version is used to communicate with the underlying PBC platform.
- **Client ABI version**: Tracks which ABI version is used to communicate with clients, for example PBC Dashboard.

Each of these versions can be incremented individually, and employ semantic versioning:

- Major versions represent backwards incompatible changes. A 2.1.3 binder cannot run a contract compiled with the 1.1.3 SDK.
- Minor versions represent forwards incompatible changes. A 2.1.3 binder cannot run a contract compiled with the 2.2.3 SDK.
- Patch versions represent backwards and forwards compatible changes. A 2.1.3 binder _can_ run a contract compiled with the 2.1.9 SDK.

The minor version constraint might seem counter-intuitive, but consider the case where a new feature `poke()` is added to the blockchain for binder version 2.3.0. The old 2.2.9 binder doesn't know how to poke, and if it ran a poking contract compiled for binder ABI 2.3.0, it would not know what to do, so it would crash rather than doing the wrong thing. Crashing is undesirable, so we prefer to reject all contracts for a higher minor version.

## Usage

For contract development, use the `Cargo partisia-contract` tool to create a toml with the correct dependencies and features. The tool can be installed using
```bash
  cargo install cargo-partisia-contract
```

### Cheap memcpy

The `pbc_lib` crate overwrites internal Rust functions with cheaper
alternatives that uses PBC internals. To overwrite these functions, you must
add following to your root module:

```rust
extern crate pbc_lib as _;
```

## ABI generation

When compile a contract with the `abi` feature flag, several exported functions with a `__abi`
prefix are made available to help generate the contract ABI.

- `__abi_generate_to_ptr` - Deprecated ABI generating function
- `__abi_state_generate_to_ptr` - ABI generating function
- `__abi_malloc` - Allocate vector in memory
- `__abi_fn_as_fn_ptr___abi_fn_{kind_id}_{shortname}_{fn_name}` - Several functions for each of the
  declared actions in the contract. Pointers to functions that can generate ABI for a specific
  contract action.

The input and output of each function is documented in the rust code.

To generate the ABI of a contract the following steps give a quick overview of how to do so:

1. Find all exported functions on the format `__abi_fn_as_fn_ptr___abi_fn_{kind_id}_{shortname}_{fn_name}`
2. Sort the functions as needed by `{kind_id}` and `{shortname}`.
3. Call each function in turn to retrieve the function pointers to the `__abi_fn_{kind_id}_{shortname}_{fn_name}` functions.
4. Allocate a list in memory that is big enough to hold the list of function pointers (e.g. 4*len, if each pointer is 4 bytes).
5. Write all the function pointers to the list.
6. Call `__abi_state_generate_to_ptr` with the length of the function pointers and a pointer to the list in memory.
7. Read the ABI from memory, using the returned buffer pointer and length.

## Migration from REAL Binder 9.X.X to 10.X.X for ZK contracts

You will need to update your ZK contract code to compile for Binder 10.X.X.

The `10.0.0` version allows the contract full control over deletion, transfer
and opening of user variables, whereas the older binder versions prevented the
contract from these actions.  ZK contracts are now more flexible with respect
to user variables, regardless of the owner and the stage of the calculation,
which have made the below-mentioned items redundant.

The following changes have been made:

- [`CalculationStatus::Output`] merged into [`CalculationStatus::Waiting`].
- `zk_on_user_variables_opened` merged into [`zk_on_variables_opened`].
- [`ZkStateChange::OutputComplete`] replaced with [`ZkStateChange::DeleteVariables`].

These changes allows the contract to treat user variables equally to
contract owned variables.

You should update your ZK-contract code as follows:

- Checks for [`CalculationStatus::Output`] are no longer needed, and can be removed.
- Replace usages of `zk_on_user_variables_opened` with [`zk_on_variables_opened`].
- [`ZkStateChange::OutputComplete`] can be replaced with [`ZkStateChange::DeleteVariables`].

## Version History

| **Rust Crate** | **PUB Binder** | **REAL Binder** | **Client** | **SDK** | **Changes**                                                                                                                                                                                                                                                                              |
|---------------:|---------------:|----------------:|-----------:|--------:|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|          7.7.0 |         10.4.0 |          11.5.0 |      5.6.0 | 16.74.0 | **Public only**: Contract upgrading implemented, using the `#[upgrade]` and `#[upgrade_is_allowed]` macros. ZK contracts do not support this. |
|          7.6.0 |         10.3.0 |          11.5.0 |      5.6.0 | 16.68.0 | Support for Rust 1.82. **ZK Only**: Updated functionality such that only three node reactions are required for zk-inputs and outputs instead of all four.                                                                                                                                             |
|          7.5.0 |         10.2.0 |          11.4.0 |      5.6.0 | 16.63.0 | **ZK Only**: Added support for unsigned secret comparisons.                                                                                                                                                                                                                                           |
|          7.4.0 |         10.2.0 |          11.3.0 |      5.6.0 | 16.62.0 | **ZK Only**: Added new ABI type for sized arrays of any type `[T; LEN]`.                                                                                                                                                                                                                              |
|          7.3.0 |         10.2.0 |          11.3.0 |      5.5.0 | 16.60.0 | **ZK Only**: Added unsigned secret integers `Sbu`. Added support for `Vec<u8>` as zk-input. Make EVM oracle nodes send heartbeat blocks for inactive event subscriptions.                                                                                                                             |
|          7.2.0 |         10.2.0 |          11.2.0 |      5.5.0 | 16.52.0 | **ZK Only**: `[ZkStateChange::StartComputation`] and [`ZkInputDef`] can now control which `zk_on_compute_complete` and `zk_on_variable_inputted` hook to be invoked with, once the relevant event has completed. `zk_on_compute_complete` and `zk_on_variable_inputted` must now be given shortnames. |
|          7.1.0 |         10.2.0 |          11.1.0 |      5.4.0 | 16.42.0 | **ZK Only**: Fixed issue with requesting preprocessing material                                                                                                                                                                                                                                       |
|          7.0.0 |         10.2.0 |          11.0.0 |      5.4.0 | 16.36.0 | **ZK Only**: Moved ZkVariables into AvlTreeMaps with special tree ids.                                                                                                                                                                                                                                |
|          6.3.0 |         10.2.0 |          10.3.0 |      5.4.0 | 16.29.0 | **ZK Only**: Added [`ZkStateChange::SubscribeToEvmEvents`] and [`ZkStateChange::UnsubscribeFromEvmEvents`] functions. Added `zk_on_external_event` hook.                                                                                                                                              |
|          6.2.0 |         10.2.0 |          10.2.0 |      5.3.0 | 16.24.0 | Added `iter` and `len` functionality to `AvlTreeMap`.                                                                                                                                                                                                                                    |
|          6.1.0 |         10.1.0 |          10.1.0 |      5.3.0 | 16.17.0 | Added `AvlTreeMap` map implementation that allows for partial deserialization of state. map                                                                                                                                                                                              |
|          6.0.0 |          9.5.0 |          10.0.0 |      5.2.0 |  16.8.0 | **ZK Only**: Contracts can now delete, transfer and open any variable, regardless of owner and calculation stage. Removes `zk_on_user_variables_opened` and the output phase of ZK contracts.                                                                                                         |
|          5.0.1 |          9.5.0 |           9.5.0 |      5.2.0 |  16.1.0 | Support for Rust 1.70. New wasm instructions - sign extension.                                                                                                                                                                                                                           |
|          5.0.1 |          9.4.0 |           9.4.0 |      5.2.0 |  16.0.1 | **ZK Only**: Fixed bug whereby `start_computation` variants produced wrong RPC.                                                                                                                                                                                                                       |
|          5.0.0 |          9.4.0 |           9.4.0 |      5.2.0 |  16.0.0 | **ZK Only**: `start_computation` and `start_computation_with_inputs` now requires shortnames for ZK Computations.                                                                                                                                                                                     |
|          4.4.0 |          9.4.0 |           9.4.0 |      5.2.0 |  15.4.0 | Added `SortedVecSet` and `SortedVec` as gas-efficient Set and Sorted List collections.                                                                                                                                                                                                                   |
|          4.3.0 |          9.4.0 |           9.4.0 |      5.2.0 |  15.3.0 | Removed unused `log_external` function, as it caused linker errors in certain setups.                                                                                                                                                                                                    |
|          4.2.0 |          9.4.0 |           9.4.0 |      5.2.0 |  15.2.0 | Added `with_cost_from_contract` to interaction builder for support for sending events using the contract's gas.                                                                                                                                                                          |
|          4.1.0 |          9.0.0 |           9.3.0 |      5.2.0 |  15.1.0 | **ZK Only**: Added `secret_variable_ids()` to `pbc_zk`. Deprecated `num_secret_variables()`.                                                                                                                                                                                                          |
|          4.0.0 |          9.0.0 |           9.3.0 |      5.2.0 |  15.0.0 | **ZK Only**: Removed the zk feature. Instead macros now take an optional argument zk. For an action or a callback to be zk the init must also be zk.                                                                                                                                                  |
|          3.0.0 |          9.0.0 |           9.3.0 |      5.2.0 |  14.0.0 | Added new SortedVecMap with faster serialization. Removed support for `BTreeMap`. `#[derive(ReadWriteState)]`, `#[derive(ReadWriteRPC)]` and `#[derive(CreateTypeSpec)]` now supports generics.                                                                                                                 |
|          2.2.0 |          9.0.0 |           9.3.0 |      5.2.0 |  13.6.0 | **ZK Only**: Added support for user events in ZK contracts.                                                                                                                                                                                                                                           |
|          2.2.0 |          9.0.0 |           9.2.0 |      5.2.0 |  13.5.0 | **ZK Only**: Added support for `#[on_secret_input]` hook to take an arbitrary secret type as input.                                                                                                                                                                                                      |
|          2.1.0 |          9.0.0 |           9.2.0 |      5.1.0 |  13.4.0 | Added more built-in types: U256, Hash, PublicKey, Signature, BlsPublicKey, BlsSignature. Distinguish between public and REAL contracts, when adding version.                                                                                                                          |
|          2.1.0 |          9.2.0 |           9.2.0 |      5.0.0 |  13.3.0 | **ZK Only**: Added support for XOR, SUBTRACT and OUTPUT instructions.                                                                                                                                                                                                                                 |
|          2.1.0 |          9.1.0 |           9.1.0 |      5.0.0 |  13.2.0 | Added support for adding gas to contract via an empty invocation.                                                                                                                                                                                                                        |
|          2.1.0 |          9.0.0 |           9.0.0 |      5.0.0 |  13.1.0 | **ZK Only**: Added support for `#[derive(SecretBinary)]` for `pbc_zk`.                                                                                                                                                                                                                                |
|          2.0.0 |          9.0.0 |           9.0.0 |      5.0.0 |  13.0.0 | ReadWriteRPC trait split into two: ReadRPC and WriteRPC. The state macro no longer adds derive(Clone). The CreateTypeSpec derive only adds derive(ReadRPC) and not write.                                                                                                                |
|          1.7.0 |          9.0.0 |           9.0.0 |      5.0.0 |  12.0.0 | Disabled option to send from original sender. Added ping method to check if a contract is alive.                                                                                                                                                                                         |
|          1.7.0 |          8.1.0 |           8.1.0 |      5.0.0 |  11.0.0 | Added support for enum with struct variants in RPC, State and ABI.                                                                                                                                                                                                                       |
|          1.6.0 |          8.1.0 |           8.1.0 |      4.1.0 |  10.1.0 | **ZK Only**: ZK-computations can now be called with open (non-secret) inputs.                                                                                                                                                                                                                         |
|          1.5.0 |          8.0.0 |           8.0.0 |      4.1.0 |  10.0.0 | Added support for return values from actions and callbacks. `pbc_contract_common::signature::Signature` and `std::collections::VecDeque` can now be used in RPC and State.                                                                                                               |
|          1.4.6 |          7.0.0 |           7.0.0 |      4.1.0 |   9.1.2 | **ZK Only**: Added `pbc_zk` lib for testing contracts.                                                                                                                                                                                                                                                |
|          1.4.5 |          7.0.0 |           7.0.0 |      4.1.0 |   9.1.1 | Removed implicit circular reference that prevented linking with `CARGO_INCREMENTAL=0`. Non-path dependencies are now allowed.                                                                                                                                                            |
|          1.4.4 |          7.0.0 |           7.0.0 |      4.1.0 |   9.1.0 | Added new `EventGroup::builder` API. Old `EventGroup` constructor API have been deprecated. Will be removed in a future version.                                                                                                                                                         |
|          1.4.3 |          7.0.0 |           7.0.0 |      4.1.0 |   9.0.0 | **ZK Only**: Added `#[on_attestation_complete]` function.                                                                                                                                                                                                                                                |
|          1.4.2 |          6.0.0 |           6.0.0 |      4.0.0 |   8.0.0 | Changed FFI between binder and contract result. The length of the result is now at the offset returned by the wrapped action/init functions.                                                                                                                                             |
|          1.4.1 |          5.0.0 |           5.0.0 |      4.0.0 |   7.0.0 | Changed contract argument input ABI to be more easily extendable.                                                                                                                                                                                                                        |
|          1.4.0 |          4.0.0 |           4.0.0 |      4.0.0 |   6.1.0 | Shortnames must now be specified as pre-encoded LEB128 hex literals.                                                                                                                                                                                                                     |
|          1.3.3 |          4.0.0 |           4.0.0 |      4.0.0 |   6.0.0 | Changed ABI format to include function hook kind.                                                                                                                                                                                                                                        |
|          1.3.2 |          4.0.0 |           4.0.0 |      3.0.0 |   5.0.0 | Switched `FnKind` ids for state and event sections.                                                                                                                                                                                                                                        |
|          1.3.1 |          3.1.0 |           3.1.0 |      3.0.0 |   4.2.0 | Added hosted panic handler, allowing contracts to give better error messages.                                                                                                                                                                                                            |
|          1.3.0 |          3.0.0 |           3.0.0 |      3.0.0 |   4.1.0 | Bugfixes and added ZK definitions.                                                                                                                                                                                                                                                       |
|          1.2.1 |          3.0.0 |           3.0.0 |      3.0.0 |   4.0.0 | Changed contract result ABI to be more easily extendable.                                                                                                                                                                                                                                |
|          1.2.0 |          2.1.0 |           2.1.0 |      3.0.0 |   3.1.0 | Contracts can now receive callbacks, allowing them to differentiate between successful and failed RPCs.                                                                                                                                                                                  |
|          1.1.0 |          2.0.0 |           2.0.0 |      3.0.0 |   3.0.0 | LEB128 action shortnames, to improve interoperability with Java system contracts.                                                                                                                                                                                                        |
|          1.0.0 |          1.1.0 |           1.1.0 |      2.0.0 |   2.1.0 | Added hosted memmove, allowing constant-gas memcpy and memmove functionality.                                                                                                                                                                                                            |
|          1.0.0 |          1.0.0 |           1.0.0 |      2.0.0 |   2.0.0 | Integers in state have been made little-endian, in order to lower serialization gas costs.                                                                                                                                                                                               |
|          1.0.0 |          1.0.0 |           1.0.0 |      1.0.0 |   1.0.0 | Initial                                                                                                                                                                                                                                                                                  |
